#include  <stdio.h>
#include  <math.h>    /* dla atof() */

#define   MAXOP  100   /* dopuszczalny rozmiar operandu lub operatora */
#define   NUMBER '0'   /* sygna, e pobrano liczb */

int getop(char []);
void push(double);
double pop(void);
void clear(void);

/* kalkulator z odwrotn notacj polsk */
main()
{
    int type;
    double op1, op2;
    char s[MAXOP];
    
    while ((type = getop(s)) != EOF) {
        switch (type) {
        case NUMBER:
            push(atof(s));
            break;
        case '+':
            push(pop() + pop());
            break;
        case '*':
            push(pop() * pop());
            break;
        case '-':
            op2 = pop();
            push(pop() - op2);
            break;
        case '/':
            op2 = pop();
            if (op2 != 0.0)
                push(pop() / op2);
            else
                printf("error: zero divisor\n");
            break;
        case '?':                 /* wypisz element z wierzchoka stosu */
            op2 = pop();
            printf("\t%.8g\n", op2);
            push(op2);
            break;
        case 'c':                 /* oprnij stos */
            clear();
            break;
        case 'd':                 /* duplikuj element na wierzchoku stosu */
            op2 = pop();
            push(op2);
            push(op2);
            break;
        case 's':                 /* zamie dwa elementy na wierzchoku */
            op1 = pop();
            op2 = pop();
            push(op1);
            push(op2);
            break;
        case '\n':
            printf("\t%.8g\n", pop());
            break;
        default:
            printf("error: unknown command %s\n", s);
            break;
        }
    }
    return 0;
}
